/*
 * Copyright (C) 2015  Brendan Bruner
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * bbruner@ualberta.ca
 */
/**
 * @file command_allocator
 * @author Brendan Bruner
 * @date 2015-01-28
 */
#ifndef INCLUDE_COMMAND_ALLOCATOR_H_
#define INCLUDE_COMMAND_ALLOCATOR_H_

#include <stdlib.h>
#include "commands.h"

/**
 * @brief
 * 		Allocate space for a command_t structure.
 *
 * @details
 * 		Allocate space for a command_t structure.
 *
 * @remark
 * 		Current implementation uses malloc.
 *
 * @returns
 * 		A pointer to the command_t structure which has just been allocated.
 * 		NULL if allocation failed.
 *
 * @memberof command_t
 */
#define alloc_command( )	(command_t *) malloc( sizeof( commant_t ) )

/**
 * @brief
 * 		Frees the space allocated for a command_t structure.
 *
 * @details
 * 		Frees the space allocated for a command_t structure.
 *
 * @param command
 * 		A pointer to the command_t structure to free
 *
 * @memberof command_t
 */
#define free_command( command )	free( command );

#endif /* INCLUDE_COMMAND_ALLOCATOR_H_ */
