/*
 * Copyright (C) 2015  Brendan Bruner
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * bbruner@ualberta.ca
 */
/**
 * @file task_defines
 * @author Brendan Bruner
 * @date Mar 31, 2015
 */

#include "FreeRTOS.h"
#include "task.h"

#ifndef INCLUDE_TASK_DEFINES_H_
#define INCLUDE_TASK_DEFINES_H_

#define NO_PARAMETERS				NULL
#define NO_HANDLE					NULL

#define PRINT_STACK					128
#define PRINT_PRIO					( tskIDLE_PRIORITY + 1 )
#define PRINT_NAME					"print task"
#define PRINT_DELAY					( 30000 / portTICK_RATE_MS )

#define UART_STACK					256
#define UART_PRIO					( tskIDLE_PRIORITY + 1 )
#define UART_NAME					"uart task"
#define UART_SLEEP_PERIOD			( 1000 / portTICK_RATE_MS )

#define I2C_STACK					256
#define I2C_PRIO					( tskIDLE_PRIORITY + 1 )
#define I2C_NAME					"i2c Task"
#define I2C_SLEEP_PERIOD			( 1000 / portTICK_RATE_MS )

#define HK_STACK					1400
#define HK_PRIO 					( tskIDLE_PRIORITY + 2 )
#define HK_NAME 					"HK Task"
#define HK_SLEEP_PERIOD				( 150 / portTICK_RATE_MS )

#define TELECOMMAND_STACK			512
#define TELECOMMAND_PRIO			( tskIDLE_PRIORITY + 3 )
#define TELECOMMAND_NAME			"telecommand task"
#define TELECOMMAND_SLEEP_PERIOD	( 300 / portTICK_RATE_MS )

#define TRANSMIT_STACK				1400
#define TRANSMIT_PRIO				( tskIDLE_PRIORITY + 3 )
#define TRANSMIT_NAME				"transmit task"
#define TRANSMIT_SLEEP_PERIOD		( 100 / portTICK_RATE_MS )

#define INIT_STACK					128
#define INIT_PRIO					( tskIDLE_PRIORITY + 1 )
#define INIT_NAME					"Init Task"

#define SD_STACK 					2048
#define SD_PRIO 					( tskIDLE_PRIORITY + 1 )
#define SD_NAME 					"SD_Task"
#define SD_SLEEP					100

#define COMM_GATEWAY_STACK			256
#define COMM_GATEWAY_PRIO			( tskIDLE_PRIORITY + 4 )
#define COMM_GATEWAY_NAME			"comm gateway"
#define COMM_GATEWAY_PERIOD			( 50 / portTICK_RATE_MS )

#define DELAY_ONE_SECOND	(1000 / portTICK_RATE_MS)
#define ONE_SECOND			DELAY_ONE_SECOND

#endif /* INCLUDE_TASK_DEFINES_H_ */
