/*
 * @file mock_comms_structs
 * @author Jeff Ryan
 * @date Mar 3, 2015
 */


#ifndef INCLUDE_MOCK_COMMS_STRUCT_H_
#define INCLUDE_MOCK_COMMS_STRUCT_H_

#define NANOCOM_CONF_MORSE_TEXT_LENGTH 20

typedef struct __attribute__((packed)){
	uint8_t do_rs;
	uint8_t do_random;
	uint8_t do_vitebi;
	uint8_t tx_baud;
	uint8_t rx_baud;
	int16_t tx_max_temp;
	uint16_t preamble_length;
	uint8_t morse_enable;
	uint8_t morse_mode;
	uint8_t morse_cycle;
	uint8_t morse_en_voltage;
	uint8_t morse_en_rx_count;
	uint8_t morse_en_tx_count;
	uint8_t morse_en_temp_a;
	uint8_t morse_en_temp_b;
	uint8_t morse_en_rssi;
	uint8_t morse_en_rf_err;
	uint16_t morse_inter_delay;
	uint16_t morse_pospone;
	uint8_t morse_wpm;
	uint8_t morse_text[20];
	uint16_t morse_bat_level;
	uint16_t hk_interval;
} nanocom_conf_t;


typedef struct __attribute__((packed)){
	uint32_t bit_corr_tot;
	uint32_t byte_corr_tot;
	uint32_t rx;
	uint32_t rx_err;
	uint32_t tx;
	int16_t last_temp_a;
	int16_t last_temp_b;
	int16_t last_rssi;
	int16_t last_rferr;
	uint16_t last_batt_volt;
	uint16_t last_txcurrent;
	uint32_t bootcount;
} nanocom_data_t;

typedef struct __attribute__((packed)){
	uint32_t time;
	int16_t temp_a;
	int16_t temp_b;
	uint16_t batt_volt;
} nanocom_hk_t;

typedef struct __attribute__((packed)){
	uint32_t time;
	int16_t rssi;
	int16_t rferr;
} nanocom_rssi_t;



#endif /* INCLUDE_MOCK_COMMS_STRUCT_H_ */
