/*
 * Copyright (C) 2015  Brendan Bruner
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * bbruner@ualberta.ca

*
 * @file adcs_lpc_local
 * @author Brendan Bruner
 * @date April 7, 2015
*/

#include "adcs.h"

#define MODE_CYCLE_SIZE 33
static adcs_mode_t mode_cycles[] =	{
									ADCS_MODE_IDLE, ADCS_MODE_DETUMBLE, ADCS_MODE_DETUMBLE,
									ADCS_MODE_STABILIZED, ADCS_MODE_STABILIZED, ADCS_MODE_STABILIZED,
									ADCS_MODE_STABILIZED, ADCS_MODE_DETUMBLE, ADCS_MODE_DETUMBLE,
									ADCS_MODE_STABILIZED, ADCS_MODE_STABILIZED, ADCS_MODE_STABILIZED,
									ADCS_MODE_STABILIZED, ADCS_MODE_STABILIZED, ADCS_MODE_STABILIZED,
									ADCS_MODE_STABILIZED, ADCS_MODE_STABILIZED, ADCS_MODE_STABILIZED,
									ADCS_MODE_STABILIZED, ADCS_MODE_DETUMBLE, ADCS_MODE_DETUMBLE,
									ADCS_MODE_DETUMBLE, ADCS_MODE_DETUMBLE, ADCS_MODE_DETUMBLE,
									ADCS_MODE_STABILIZED, ADCS_MODE_STABILIZED, ADCS_MODE_STABILIZED,
									ADCS_MODE_STABILIZED, ADCS_MODE_STABILIZED, ADCS_MODE_DETUMBLE,
									ADCS_MODE_DETUMBLE, ADCS_MODE_DETUMBLE, ADCS_MODE_IDLE
									};

static adcs_mode_t mode_mock_up( adcs_t *adcs )
{
	int index, next_index;

	index = (int) adcs->data;
	next_index = (++index) % MODE_CYCLE_SIZE;
	adcs->data = (void *) next_index;
	return mode_cycles[index % MODE_CYCLE_SIZE];
}


/* General telecommands*/
static void adcs_reset(adcs_t *self, adcs_reset_t *reset_type )
{
	return;
}

static void adcs_set_unix_time(adcs_t *self, adcs_unix_time_t *time)
{
	return;
}

static void adcs_set_run_mode(adcs_t *self, adcs_run_mode_t *run_mode)
{
	return;
}

static void adcs_select_logged_data(adcs_t *self, adcs_logged_data_t *logged_data)
{

	return;
}

static void adcs_select_element_power_control(adcs_t *self, adcs_power_control_t *power_state)
{
	return;
}

static void adcs_deploy_magnetometer_boom(adcs_t *self, adcs_deploy_magnetometer_boom_timeout_t *timeout)
{
	return;
}

static void adcs_trigger_adcs_loop(adcs_t *self)
{
	return;
}

static void adcs_set_attitude_estimation_mode(adcs_t *self, adcs_attitude_estimation_mode_t *estimation_mode)
{
	return;
}

static void adcs_set_attitude_control_mode(adcs_t *self, adcs_attitude_control_mode_t *control_mode)
{
	return;
}

static void adcs_set_commanded_attitude_angles(adcs_t *self, adcs_commanded_attitude_angles_t *angles)
{
	return;
}

static void adcs_set_wheel_speed(adcs_t *self, adcs_wheel_speed_t *speed)
{
	return;
}

static void adcs_set_magnetorquer_output(adcs_t *self, adcs_magnetorquer_output_t *output)
{
	return;
}

static void adcs_set_sgp4_orbit_parameters(adcs_t *self, adcs_sgp4_orbit_parameters_t *params)
{
	return;
}

static void adcs_set_curr_config(adcs_t *self, adcs_curr_config_t *config)
{
	return;
}

static void adcs_set_magnetorquer_config(adcs_t *self, adcs_magnetorquer_config_t *magnetorquer_config)
{
	return;
}
static void adcs_set_wheel_config(adcs_t *self, adcs_wheel_config_t *wheel_config)
{
	return;
}
static void adcs_set_css_config(adcs_t *self, adcs_css_config_t *css_config)
{
	return;
}
static void adcs_set_sun_sensor_config(adcs_t *self, adcs_sun_sensor_config_t *sun_sensor_config)
{
	return;
}
static void adcs_set_nadir_sensor_config(adcs_t *self, adcs_nadir_sensor_config_t *nadir_sensor_config)
{
	return;
}
static void adcs_set_magnetometer_config(adcs_t *self, adcs_magnetometer_config_t *magnetometer_config)
{
	return;
}
static void adcs_set_rate_sensor_config(adcs_t *self, adcs_rate_sensor_config_t *rate_sensor_config)
{
	return;
}
static void adcs_set_detumbling_control(adcs_t *self, adcs_detumbling_control_t *detumbling_control)
{
	return;
}
static void adcs_set_Y_momentum_control(adcs_t *self, adcs_Y_momentum_control_t *Y_momentum_control_control)
{
	return;
}
static void adcs_set_moment_of_inertia(adcs_t *self, adcs_moment_of_inertia_t *moment_of_inertia)
{
	return;
}

static void adcs_set_estimation_parameters(adcs_t *self, adcs_estimation_parameters_t *estimation_parameters)
{
	return;
}

static void adcs_save_config(adcs_t *self)
{
	return;
}

static void adcs_save_orbit_params(adcs_t *self)
{
	return;
}

static void adcs_set_start_up_mode(adcs_t *self, adcs_start_up_mode_t *start_up_mode)
{
	return;
}

static void adcs_capture_and_save_image(adcs_t *self, adcs_capture_and_save_image_t *settings)
{
	return;
}

static void adcs_reset_file_list(adcs_t *self)
{
	return;
}

static void adcs_advance_file_list_index(adcs_t *self)
{
	return;
}

static void adcs_init_download(adcs_t *self, char *filename, int length)
{
	return;
}

static void adcs_advance_file_read_pointer(adcs_t *self, adcs_next_block_num_to_read_t *block_number)
{
	return;

}

static void adcs_erase_file(adcs_t *self, char *filename, int length)
{
	return;

}

static void adcs_erase_all_files(adcs_t *self)
{
	return;

}

static void adcs_set_boot_index(adcs_t *self, adcs_boot_index_t *index)
{
	return;

}

static void adcs_erase_program(adcs_t *self, adcs_boot_index_t *index)
{
	return;

}

static void adcs_upload_program_block(adcs_t *self, adcs_upload_program_block_t *program_block)
{
	return;
}

static void adcs_finalize_program_upload(adcs_t *self, adcs_finalize_program_upload_t *finalize_upload_command)
{
	return;

}

/*General telemetry*/
static adcs_identification_t* adcs_send_identification(adcs_t *self)
{
	return 0;
}

static adcs_comm_status_t* adcs_send_comm_status(adcs_t *self)
{
	return 0;
}

static adcs_ack_t* adcs_send_ack(adcs_t *self)
{
	return 0;
}

static adcs_reset_cause_t* adcs_send_reset_cause(adcs_t *self)
{
	return 0;
}

static adcs_power_control_t* adcs_send_selected_element_power_control(adcs_t *self)
{
	return 0;
}

static adcs_power_and_temperature_meas_t* adcs_send_power_and_temperature_meas(adcs_t *self)
{
	return 0;
}

static adcs_cubesense_current_measurements_t* adcs_send_cubesense_current_measurement(adcs_t *self)
{
	return 0;
}
static adcs_cubecontrol_current_measurements_t* adcs_send_cubecontrol_current_measurements(adcs_t *self)
{
	return 0;
}
static adcs_peripheral_current_and_temperature_meas_t* adcs_send_peripheral_current_and_temperature_meas(adcs_t *self)
{
	return 0;
}

static adcs_state_t* adcs_send_state(adcs_t *self)
{
	return 0;
}

static adcs_unix_time_t* adcs_send_curr_time(adcs_t *self)
{
	return 0;
}
static adcs_curr_state_t* adcs_send_curr_state(adcs_t *self)
{
	return 0;
}
static adcs_estimated_attitude_angles_t* adcs_send_estimated_attitude_angles(adcs_t *self)
{
	return 0;
}
static adcs_estimated_angular_rates_t* adcs_send_estimated_angular_rates(adcs_t *self)
{
	return 0;
}
static adcs_satellite_velocity_t* adcs_send_satellite_velocity(adcs_t *self)
{
	return 0;
}
static adcs_satellite_position_t* adcs_send_satellite_position(adcs_t *self)
{
	return 0;
}

static adcs_measurements_t* adcs_send_measurements(adcs_t *self)
{
	return 0;
}

static adcs_magnetic_field_vector_t* adcs_send_magnetic_field_vector(adcs_t *self)
{
	return 0;
}
static adcs_coarse_sun_vector_t* adcs_send_coarse_sun_vector(adcs_t *self)
{
	return 0;
}
static adcs_fine_sun_vector_t* adcs_send_fine_sun_vector(adcs_t *self)
{
	return 0;
}
static adcs_nadir_vector_t* adcs_send_nadir_vector(adcs_t *self)
{
	return 0;
}
static adcs_rate_sensor_rates_t* adcs_send_rate_sensor_rates(adcs_t *self)
{
	return 0;
}
static adcs_wheel_speed_meas_t* adcs_send_wheel_speed_meas(adcs_t *self)
{
	return 0;
}

static adcs_actuator_command_t* adcs_send_actuator_command(adcs_t *self)
{
	return 0;
}

static adcs_magnetorquer_command_t* adcs_send_magnetorquer_command(adcs_t *self)
{
	return 0;
}
static adcs_wheel_speed_command_t* adcs_send_wheel_speed_command(adcs_t *self)
{
	return 0;
}

static adcs_raw_sensor_measurements_t* adcs_send_raw_sensor_measurements(adcs_t *self)
{
	return 0;
}

static adcs_raw_nadir_sensor_t* adcs_send_raw_nadir_sensor(adcs_t *self)
{
	return 0;
}
static adcs_raw_sun_sensor_t* adcs_send_raw_sun_sensor(adcs_t *self)
{
	return 0;
}
static adcs_raw_css_t* adcs_send_raw_css(adcs_t *self)
{
	return 0;
}
static adcs_raw_magnetometer_t* adcs_send_raw_magnetometer(adcs_t *self)
{
	return 0;
}
static adcs_raw_GPS_status_t* adcs_send_raw_GPS_status(adcs_t *self)
{
	return 0;
}
static adcs_raw_GPS_time_t* adcs_send_raw_GPS_time(adcs_t *self)
{
	return 0;
}
static adcs_raw_GPS_x_t* adcs_send_raw_GPS_x(adcs_t *self)
{
	return 0;
}
static adcs_raw_GPS_y_t* adcs_send_raw_GPS_y(adcs_t *self)
{
	return 0;
}
static adcs_raw_GPS_z_t* adcs_send_raw_GPS_z(adcs_t *self)
{
	return 0;
}

static adcs_estimation_data_t* adcs_send_estimation_data(adcs_t *self)
{
	return 0;
}

static adcs_IGRF_modelled_magnetic_field_vector_t* adcs_send_IGRF_modelled_magnetic_field_vector(adcs_t *self)
{
	return 0;
}
static adcs_modelled_sun_vector_t* adcs_send_modelled_sun_vector(adcs_t *self)
{
	return 0;
}
static adcs_estimated_gyro_bias_t* adcs_send_estimated_gyro_bias(adcs_t *self)
{
	return 0;
}
static adcs_estimated_innovation_vector_t* adcs_send_estimated_innovation_vector(adcs_t *self)
{
	return 0;
}
static adcs_quaternion_error_vector_t* adcs_send_quaternion_error_vector(adcs_t *self)
{
	return 0;
}
static adcs_quaternion_covariance_t* adcs_send_quaternion_covariance(adcs_t *self)
{
	return 0;
}
static adcs_angular_rate_covariance_t* adcs_send_angular_rate_covariance(adcs_t *self)
{
	return 0;
}

static adcs_ACP_execution_state_t* adcs_send_ACP_execution_state(adcs_t *self)
{
	return 0;
}

static adcs_ACP_execution_times_t* adcs_send_ACP_execution_times(adcs_t *self)
{
	return 0;
}

static adcs_sgp4_orbit_parameters_t* adcs_send_sgp4_orbit_parameters(adcs_t *self)
{
	return 0;
}

static adcs_curr_config_t* adcs_send_curr_config(adcs_t *self)
{
	return 0;
}

static adcs_EDAC_and_latchup_counters_t* adcs_send_EDAC_and_latchup_counters(adcs_t *self)
{
	return 0;
}

static adcs_start_up_mode_t* adcs_send_start_up_mode(adcs_t *self)
{
	return 0;
}

static adcs_image_capture_and_save_operations_statuses_t* adcs_send_image_capture_and_save_operations_statuses(adcs_t *self)
{
	return 0;
}

static adcs_file_info_t* adcs_send_file_info(adcs_t *self)
{
	return 0;
}

static adcs_file_block_CRC_t* adcs_send_file_block_CRC(adcs_t *self)
{
	return 0;
}

//static unsigned char block2048[8*256];
static void* adcs_send_data_block(adcs_t *self)
{
	return 0;
}

static adcs_uploaded_program_status_t* adcs_send_uploaded_program_status(adcs_t *self)
{
	return 0;
}

static adcs_flash_program_list_t* adcs_send_flash_program_list(adcs_t *self)
{
	return 0;
}

/***********************************************************************
 Initialization
***********************************************************************/
void initialize_adcs_lpc_local( adcs_t *adcs )
{
	adcs->data = (void *) 0;
	adcs->reset_count = 0;
	adcs->mode = &mode_mock_up;
	adcs->adcs_reset = &adcs_reset;
	adcs->adcs_set_unix_time = &adcs_set_unix_time;
	adcs->adcs_set_run_mode = &adcs_set_run_mode;
	adcs->adcs_select_logged_data = &adcs_select_logged_data;
	adcs->adcs_select_element_power_control = &adcs_select_element_power_control;
	adcs->adcs_deploy_magnetometer_boom = &adcs_deploy_magnetometer_boom;
	adcs->adcs_trigger_adcs_loop = &adcs_trigger_adcs_loop;
	adcs->adcs_set_attitude_estimation_mode = &adcs_set_attitude_estimation_mode;
	adcs->adcs_set_attitude_control_mode = &adcs_set_attitude_control_mode;
	adcs->adcs_set_commanded_attitude_angles = &adcs_set_commanded_attitude_angles;
	adcs->adcs_set_wheel_speed = &adcs_set_wheel_speed;
	adcs->adcs_set_magnetorquer_output = &adcs_set_magnetorquer_output;
	adcs->adcs_set_sgp4_orbit_parameters = &adcs_set_sgp4_orbit_parameters;
	adcs->adcs_set_curr_config = &adcs_set_curr_config;
	adcs->adcs_set_magnetorquer_config = &adcs_set_magnetorquer_config;
	adcs->adcs_set_wheel_config = &adcs_set_wheel_config;
	adcs->adcs_set_css_config = &adcs_set_css_config;
	adcs->adcs_set_sun_sensor_config = &adcs_set_sun_sensor_config;
	adcs->adcs_set_nadir_sensor_config = &adcs_set_nadir_sensor_config;
	adcs->adcs_set_magnetometer_config = &adcs_set_magnetometer_config;
	adcs->adcs_set_rate_sensor_config = &adcs_set_rate_sensor_config;
	adcs->adcs_set_detumbling_control = &adcs_set_detumbling_control;
	adcs->adcs_set_Y_momentum_control = &adcs_set_Y_momentum_control;
	adcs->adcs_set_moment_of_inertia = &adcs_set_moment_of_inertia;
	adcs->adcs_set_estimation_parameters = &adcs_set_estimation_parameters;
	adcs->adcs_save_config = &adcs_save_config;
	adcs->adcs_save_orbit_params = &adcs_save_orbit_params;
	adcs->adcs_set_start_up_mode = &adcs_set_start_up_mode;
	adcs->adcs_capture_and_save_image = &adcs_capture_and_save_image;
	adcs->adcs_reset_file_list = &adcs_reset_file_list;
	adcs->adcs_advance_file_list_index = &adcs_advance_file_list_index;
	adcs->adcs_init_download = &adcs_init_download;
	adcs->adcs_advance_file_read_pointer = &adcs_advance_file_read_pointer;
	adcs->adcs_erase_file = &adcs_erase_file;
	adcs->adcs_erase_all_files = &adcs_erase_all_files;
	adcs->adcs_set_boot_index = &adcs_set_boot_index;
	adcs->adcs_erase_program = &adcs_erase_program;
	adcs->adcs_upload_program_block = &adcs_upload_program_block;
	adcs->adcs_finalize_program_upload = &adcs_finalize_program_upload;
	adcs->adcs_send_identification = &adcs_send_identification;
	adcs->adcs_send_comm_status = &adcs_send_comm_status;
	adcs->adcs_send_ack = &adcs_send_ack;
	adcs->adcs_send_reset_cause = &adcs_send_reset_cause;
	adcs->adcs_send_selected_element_power_control = &adcs_send_selected_element_power_control;
	adcs->adcs_send_power_and_temperature_meas = &adcs_send_power_and_temperature_meas;
	adcs->adcs_send_cubesense_current_measurement = &adcs_send_cubesense_current_measurement;
	adcs->adcs_send_cubecontrol_current_measurements = &adcs_send_cubecontrol_current_measurements;
	adcs->adcs_send_peripheral_current_and_temperature_meas = &adcs_send_peripheral_current_and_temperature_meas;
	adcs->adcs_send_state = &adcs_send_state;
	adcs->adcs_send_curr_time = &adcs_send_curr_time;
	adcs->adcs_send_curr_state = &adcs_send_curr_state;
	adcs->adcs_send_estimated_attitude_angles = &adcs_send_estimated_attitude_angles;
	adcs->adcs_send_estimated_angular_rates = &adcs_send_estimated_angular_rates;
	adcs->adcs_send_satellite_velocity = &adcs_send_satellite_velocity;
	adcs->adcs_send_satellite_position = &adcs_send_satellite_position;
	adcs->adcs_send_measurements = &adcs_send_measurements;
	adcs->adcs_send_magnetic_field_vector = &adcs_send_magnetic_field_vector;
	adcs->adcs_send_coarse_sun_vector = &adcs_send_coarse_sun_vector;
	adcs->adcs_send_fine_sun_vector = &adcs_send_fine_sun_vector;
	adcs->adcs_send_nadir_vector = &adcs_send_nadir_vector;
	adcs->adcs_send_rate_sensor_rates = &adcs_send_rate_sensor_rates;
	adcs->adcs_send_wheel_speed_meas = &adcs_send_wheel_speed_meas;
	adcs->adcs_send_actuator_command = &adcs_send_actuator_command;
	adcs->adcs_send_magnetorquer_command = &adcs_send_magnetorquer_command;
	adcs->adcs_send_wheel_speed_command = &adcs_send_wheel_speed_command;
	adcs->adcs_send_raw_sensor_measurements = &adcs_send_raw_sensor_measurements;
	adcs->adcs_send_raw_nadir_sensor = &adcs_send_raw_nadir_sensor;
	adcs->adcs_send_raw_sun_sensor = &adcs_send_raw_sun_sensor;
	adcs->adcs_send_raw_css = &adcs_send_raw_css;
	adcs->adcs_send_raw_magnetometer = &adcs_send_raw_magnetometer;
	adcs->adcs_send_raw_GPS_status = &adcs_send_raw_GPS_status;
	adcs->adcs_send_raw_GPS_time = &adcs_send_raw_GPS_time;
	adcs->adcs_send_raw_GPS_x = &adcs_send_raw_GPS_x;
	adcs->adcs_send_raw_GPS_y = &adcs_send_raw_GPS_y;
	adcs->adcs_send_raw_GPS_z = &adcs_send_raw_GPS_z;
	adcs->adcs_send_estimation_data = &adcs_send_estimation_data;
	adcs->adcs_send_IGRF_modelled_magnetic_field_vector = &adcs_send_IGRF_modelled_magnetic_field_vector;
	adcs->adcs_send_modelled_sun_vector = &adcs_send_modelled_sun_vector;
	adcs->adcs_send_estimated_gyro_bias = &adcs_send_estimated_gyro_bias;
	adcs->adcs_send_estimated_innovation_vector = &adcs_send_estimated_innovation_vector;
	adcs->adcs_send_quaternion_error_vector = &adcs_send_quaternion_error_vector;
	adcs->adcs_send_quaternion_covariance = &adcs_send_quaternion_covariance;
	adcs->adcs_send_angular_rate_covariance = &adcs_send_angular_rate_covariance;
	adcs->adcs_send_ACP_execution_state = &adcs_send_ACP_execution_state;
	adcs->adcs_send_ACP_execution_times = &adcs_send_ACP_execution_times;
	adcs->adcs_send_sgp4_orbit_parameters = &adcs_send_sgp4_orbit_parameters;
	adcs->adcs_send_curr_config = &adcs_send_curr_config;
	adcs->adcs_send_EDAC_and_latchup_counters = &adcs_send_EDAC_and_latchup_counters;
	adcs->adcs_send_start_up_mode = &adcs_send_start_up_mode;
	adcs->adcs_send_image_capture_and_save_operations_statuses = &adcs_send_image_capture_and_save_operations_statuses;
	adcs->adcs_send_file_info = &adcs_send_file_info;
	adcs->adcs_send_file_block_CRC = &adcs_send_file_block_CRC;
	adcs->adcs_send_data_block = &adcs_send_data_block;
	adcs->adcs_send_uploaded_program_status = &adcs_send_uploaded_program_status;
	adcs->adcs_send_flash_program_list = &adcs_send_flash_program_list;
}
