/*
 * Copyright (C) 2015  Stefan Damkjar
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * bbruner@ualberta.ca
 */
/**
 * @file nanopower.c
 * @author Stefan Damkjar
 * @date Feb 14, 2015
 */

#include <nanopower.h>

static int v_counter = 0;
static int i_counter = 0;
#define SIZE_OF_VOLTAGES 65
static uint16_t voltages[] = 			{
										 17000, 17000, 17000, 17000, 16500,
										 16500, 16450, 16450, 16300, 16300,
										 16250, 16250, 16200, 16200, 16200,
										 16100, 16100, 16100, 16100, 16100,
										 16100, 16100, 16000, 16000, 16000,
										 15950, 15950, 15950, 15900, 15900,
										 15850, 15850, 15850, 15850, 15850,
										 15850, 15800, 15800, 15800, 15600,
										 15600, 15600, 15700, 15700, 15750,
										 15750, 15800, 15900, 15900, 15900,
										 15950, 16000, 16000, 16300, 16350,
										 16400, 16600, 16600, 16700, 16900,
										 16900, 16950, 16950, 16950, 16950
										};
static uint16_t currents[] = {1111, 2222, 3333, 4444, 5555, 6666, 7777, 8888, 9999};
#define SIZE_OF_CURRENTS (sizeof(currents)/sizeof(uint16_t))

int eps_hk_get( eps_hk_t * eps_hk )
{
	eps_hk->vbatt = voltages[v_counter++ % SIZE_OF_VOLTAGES];
	eps_hk->curin[0] = currents[i_counter++ % SIZE_OF_CURRENTS];
	eps_hk->curin[1] = currents[i_counter++ % SIZE_OF_CURRENTS];
	eps_hk->curin[2] = currents[i_counter++ % SIZE_OF_CURRENTS];

	return COMM_HK_SUCCESS;
}

